local siloClient = require("silo.client")

siloClient("ingress", function(ctx)
  local config = ctx.config
    :group("ingress_worker", "Ingress worker options")
    :define("ingress_containers", "The containers to accept ingress from", { "minecraft:ender chest_X" })
    :get()

  local messaging = ctx:require("silo.messaging")

  ctx:addTask(function()
    print("Scanning " .. #config["ingress_containers"] .. " containers...")

    while true do
      local scanning = ctx.server ~= -1

      if not scanning then
        sleep(0.05)
      else
        local chests = {}

        for _, container in pairs(config["ingress_containers"]) do
          local p = peripheral.wrap(container)
          if next(p.list()) ~= nil then
            table.insert(chests, container)
          end
        end

        if next(chests) ~= nil then
          scanning = false

          messaging:sendDirect(ctx.server, {
            type = "storage.deposit_items",
            chests = chests,
          }, function(...)
            scanning = true
          end)
        end
      end
    end
  end)

  ctx:run()
end)
